/* $Id: cpl_image_defs.h,v 1.11 2005/11/22 16:23:17 yjung Exp $
 *
 * This file is part of the ESO Common Pipeline Library
 * Copyright (C) 2001-2004 European Southern Observatory
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * $Author: yjung $
 * $Date: 2005/11/22 16:23:17 $
 * $Revision: 1.11 $
 * $Name: cpl-3_1 $
 */

#ifndef CPL_IMAGE_DEFS_H
#define CPL_IMAGE_DEFS_H

/*-----------------------------------------------------------------------------
                                   Includes
 -----------------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <limits.h>

#include "cpl_image.h"
#include "cpl_type.h"
#include "cpl_mask.h"

CPL_BEGIN_DECLS

/*-----------------------------------------------------------------------------
                                   Define
 -----------------------------------------------------------------------------*/

#define CPL_CLASS_NONE      0
#define CPL_CLASS_DOUBLE    1
#define CPL_CLASS_FLOAT     2
#define CPL_CLASS_INT       3

/*-----------------------------------------------------------------------------
                                New types
 -----------------------------------------------------------------------------*/

struct _cpl_image_ {
    /* Size of the image in x and y */
    int                 nx, ny ;
    /* Type of the pixels used for the cpl_image */
    cpl_type            type ;
    /* Pointer to pixel buffer as a 1d buffer */
    void            *   pixels ;
    /* Bad Pixels mask */
    cpl_mask        *   bpm ;
};

CPL_END_DECLS

#endif 

