/* $Id: cpl_image_stats_body.h,v 1.19 2006/05/09 15:14:26 yjung Exp $
 *
 * This file is part of the ESO Common Pipeline Library
 * Copyright (C) 2001-2004 European Southern Observatory
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* Type dependent macros */
#if CPL_CLASS == CPL_CLASS_DOUBLE
#define CPL_TYPE double
#define CPL_TYPE_T CPL_TYPE_DOUBLE

#elif CPL_CLASS == CPL_CLASS_FLOAT
#define CPL_TYPE float
#define CPL_TYPE_T CPL_TYPE_FLOAT

#elif CPL_CLASS == CPL_CLASS_INT
#define CPL_TYPE int
#define CPL_TYPE_T CPL_TYPE_INT

#else
#undef CPL_TYPE
#undef CPL_TYPE_T
#endif

#if CPL_OPERATION == CPL_IMAGE_STATS_MEDIAN_SUBW

    case CPL_TYPE_T:
    {
        CPL_TYPE * pi;

        pi = (CPL_TYPE*)image->pixels ;
        for (j=lly-1 ; j<ury ; j++) {
            for (i=llx-1 ; i<urx ; i++) {
                pos = i+j*image->nx ;
                /* Take only good pixels */
                if ((pbpm==NULL) || 
                    ((pbpm != NULL) && (pbpm[pos] == CPL_BINARY_0))) {
                    copybuf[ngood]=(double)pi[pos] ; 
                    ngood++ ;
                }
            }
        }
        break ;
    }

#elif CPL_OPERATION == CPL_IMAGE_STATS_MEDIAN_STAT

  case CPL_TYPE_T:
  {
      CPL_TYPE * pi;

      pi = (CPL_TYPE*)image->pixels ;
      for (i=0 ; i<npix ; i++)
          if (!badmap[i]) *sigma+= fabs((double)(pi[i]-median_val));
      break ;
  }


#endif

#undef CPL_TYPE
#undef CPL_TYPE_T
